<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" />
  <!-- <meta http-equiv="refresh" content="5" /> -->

  <script type="text/javascript" src="http://static.robotwebtools.org/EaselJS/current/easeljs.min.js"></script>
  <script type="text/javascript"
    src="http://static.robotwebtools.org/EventEmitter2/current/eventemitter2.min.js"></script>
  <script type="text/javascript" src="http://static.robotwebtools.org/roslibjs/current/roslib.min.js"></script>
  <script type="text/javascript" src="http://static.robotwebtools.org/ros2djs/current/ros2d.min.js"></script>
  <script type="text/javascript" src="js/nav2d.js"></script>

  <script type="text/javascript" type="text/javascript">
    /**
     * Setup all visualization elements when the page is loaded.
     */

    function init() {
      // Connect to ROS.
      var ros = new ROSLIB.Ros({
        url: 'ws://192.168.1.11:9090'
      });
      var viewer = new ROS2D.Viewer({
        divID: 'map',
        width: 800,
        height: 800,
      });

      NAV2D.OccupancyGridClientNav({
        ros: ros,
        rootObject: viewer.scene,
        viewer: viewer,
        continuous: true,
        serverName: '/move_base',
        actionName: 'move_base_msgs/MoveBaseActionGoal',

      });
      

      // let gridClient = new ROS2D.OccupancyGridClient({
      //   ros: ros,
      //   rootObject: viewer.scene,
      //   continuous: true,
      // });
      // // Scale the canvas to fit to the map
      // gridClient.on('change', function () {
      //   viewer.scaleToDimensions(gridClient.currentGrid.width, gridClient.currentGrid.height);
      //   viewer.shift(gridClient.currentGrid.pose.position.x, gridClient.currentGrid.pose.position.y);
      // });

      // var createFunc = function (handlerToCall, discriminator, robotMarker) {
      //   return discriminator.subscribe(function (odom) {
      //     robotMarker.x = odom.pose.pose.position.x;
      //     robotMarker.y = -odom.pose.pose.position.y;
      //     var quaZ = -odom.pose.pose.orientation.z;
      //     var quaternion = new ROSLIB.Quaternion(odom.pose.pose.orientation);
      //     console.log(quaternion.prototype);
      //     var degreeZ = 0;
      //     if (quaZ >= 0) {
      //       degreeZ = quaZ / 1 * 180
      //     } else {
      //       degreeZ = (-quaZ) / 1 * 180 + 180
      //     };
      //     robotMarker.rotation = degreeZ;
      //   })
      // }

      // var robotMarkers = [];

      // // Setup the map client.
      // var robotMarker = new ROS2D.NavigationArrow({
      //   size: 0.25,
      //   strokeSize: 0.05,
      //   pulse: true,
      //   fillColor: createjs.Graphics.getRGB(0, 0, 0, 0.65)
      // });
      // robotMarkers.push(robotMarker)
      // var poseTopic = new ROSLIB.Topic({
      //   ros: ros,
      //   name: '/odom',
      //   messageType: 'nav_msgs/Odometry'
      // });
      // createFunc('subscribe', poseTopic, robotMarker);

      // for (let i = 0; i < robotMarkers.length; i++) {
      //   gridClient.rootObject.addChild(robotMarkers[i]);
      // }

    }
  </script>
</head>

<body onload="init()" style="margin: 0px; background-color: rgb(127, 127, 127);">

  <div id="map"></div>
</body>

</html>